org.springframework.web.servlet.i18n

## Class SessionLocaleResolver

- java.lang.Object
- - org.springframework.web.servlet.i18n.AbstractLocaleResolver
  - - org.springframework.web.servlet.i18n.AbstractLocaleContextResolver
    - - org.springframework.web.servlet.i18n.SessionLocaleResolver

- All Implemented Interfaces:
    LocaleContextResolver, LocaleResolver

      public class SessionLocaleResolver
      extends AbstractLocaleContextResolver

  `LocaleResolver` implementation that uses a locale attribute in the user's session in case of a custom setting, with a fallback to the specified default locale or the request's accept-header locale.

  This is most appropriate if the application needs user sessions anyway, that is, when the HttpSession does not have to be created for the locale. The session may optionally contain an associated time zone attribute as well; alternatively, you may specify a default time zone.

  Custom controllers can override the user's locale and time zone by calling `#setLocale(Context)` on the resolver, e.g. responding to a locale change request. As a more convenient alternative, consider using `RequestContext.changeLocale(java.util.Locale)`.

  Since:
    27.02.2003
  Author:
    Juergen Hoeller
  See Also:
    `AbstractLocaleResolver.setDefaultLocale(java.util.Locale)`, `AbstractLocaleContextResolver.setDefaultTimeZone(java.util.TimeZone)`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `LOCALE_SESSION_ATTRIBUTE_NAME` Name of the session attribute that holds the Locale.
    `static String` | `TIME_ZONE_SESSION_ATTRIBUTE_NAME` Name of the session attribute that holds the TimeZone.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SessionLocaleResolver()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Locale` | `determineDefaultLocale(HttpServletRequest request)` Determine the default locale for the given request, Called if no Locale session attribute has been found.
    `protected TimeZone` | `determineDefaultTimeZone(HttpServletRequest request)` Determine the default time zone for the given request, Called if no TimeZone session attribute has been found.
    `Locale` | `resolveLocale(HttpServletRequest request)` Resolve the current locale via the given request.
    `LocaleContext` | `resolveLocaleContext(HttpServletRequest request)` Resolve the current locale context via the given request.
    `void` | `setLocaleContext(HttpServletRequest request, HttpServletResponse response, LocaleContext localeContext)` Set the current locale context to the given one, potentially including a locale with associated time zone information.

    - ### Methods inherited from class org.springframework.web.servlet.i18n.AbstractLocaleContextResolver

      `getDefaultTimeZone, setDefaultTimeZone, setLocale`

    - ### Methods inherited from class org.springframework.web.servlet.i18n.AbstractLocaleResolver

      `getDefaultLocale, setDefaultLocale`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### LOCALE_SESSION_ATTRIBUTE_NAME

          public static final String LOCALE_SESSION_ATTRIBUTE_NAME

      Name of the session attribute that holds the Locale. Only used internally by this implementation.

      Use `RequestContext(Utils).getLocale()` to retrieve the current locale in controllers or views.

      See Also:
        `RequestContext.getLocale()`, `RequestContextUtils.getLocale(javax.servlet.http.HttpServletRequest)`

    - #### TIME_ZONE_SESSION_ATTRIBUTE_NAME

          public static final String TIME_ZONE_SESSION_ATTRIBUTE_NAME

      Name of the session attribute that holds the TimeZone. Only used internally by this implementation.

      Use `RequestContext(Utils).getTimeZone()` to retrieve the current time zone in controllers or views.

      See Also:
        `RequestContext.getTimeZone()`, `RequestContextUtils.getTimeZone(javax.servlet.http.HttpServletRequest)`

  - ### Constructor Detail

    - #### SessionLocaleResolver

          public SessionLocaleResolver()

  - ### Method Detail

    - #### resolveLocale

          public Locale resolveLocale(HttpServletRequest request)

      Description copied from interface: `LocaleResolver`
      Resolve the current locale via the given request. Can return a default locale as fallback in any case.
      Specified by:
        `resolveLocale` in interface `LocaleResolver`
      Overrides:
        `resolveLocale` in class `AbstractLocaleContextResolver`
      Parameters:
        `request` - the request to resolve the locale for
      Returns:
        the current locale (never `null`)

    - #### resolveLocaleContext

          public LocaleContext resolveLocaleContext(HttpServletRequest request)

      Description copied from interface: `LocaleContextResolver`
      Resolve the current locale context via the given request.

      This is primarily intended for framework-level processing; consider using `RequestContextUtils` or `RequestContext` for application-level access to the current locale and/or time zone.

      The returned context may be a `TimeZoneAwareLocaleContext`, containing a locale with associated time zone information. Simply apply an `instanceof` check and downcast accordingly.

      Custom resolver implementations may also return extra settings in the returned context, which again can be accessed through downcasting.

      Parameters:
        `request` - the request to resolve the locale context for
      Returns:
        the current locale context (never `null`
      See Also:
        `LocaleResolver.resolveLocale(HttpServletRequest)`, `RequestContextUtils.getLocale(javax.servlet.http.HttpServletRequest)`, `RequestContextUtils.getTimeZone(javax.servlet.http.HttpServletRequest)`

    - #### setLocaleContext

          public void setLocaleContext(HttpServletRequest request,
                                       HttpServletResponse response,
                                       LocaleContext localeContext)

      Description copied from interface: `LocaleContextResolver`
      Set the current locale context to the given one, potentially including a locale with associated time zone information.
      Parameters:
        `request` - the request to be used for locale modification
        `response` - the response to be used for locale modification
        `localeContext` - the new locale context, or `null` to clear the locale
      See Also:
        `LocaleResolver.setLocale(HttpServletRequest, HttpServletResponse, Locale)`, `SimpleLocaleContext`, `SimpleTimeZoneAwareLocaleContext`

    - #### determineDefaultLocale

          protected Locale determineDefaultLocale(HttpServletRequest request)

      Determine the default locale for the given request, Called if no Locale session attribute has been found.

      The default implementation returns the specified default locale, if any, else falls back to the request's accept-header locale.

      Parameters:
        `request` - the request to resolve the locale for
      Returns:
        the default locale (never `null`)
      See Also:
        `AbstractLocaleResolver.setDefaultLocale(java.util.Locale)`, `ServletRequest.getLocale()`

    - #### determineDefaultTimeZone

          protected TimeZone determineDefaultTimeZone(HttpServletRequest request)

      Determine the default time zone for the given request, Called if no TimeZone session attribute has been found.

      The default implementation returns the specified default time zone, if any, or `null` otherwise.

      Parameters:
        `request` - the request to resolve the time zone for
      Returns:
        the default time zone (or `null` if none defined)
      See Also:
        `AbstractLocaleContextResolver.setDefaultTimeZone(java.util.TimeZone)`